;**************************************************************************
;*
;* FILE  loader.asm
;* Copyright (c) 2005, 2006, 2008 Daniel Kahlin <daniel@kahlin.net>
;* Written by Daniel Kahlin <daniel@kahlin.net>
;* $Id: loader.asm,v 1.28 2008-02-18 10:15:10 tlr Exp $
;*
;* DESCRIPTION
;*   load and install dtvtrans.
;*
;******
	processor 6502

; this must correspond to the TOTAL_SIZE from the dtvtrans server
TOTAL_SIZE	equ	$0db6


;dtv SAC #<imm>
	MAC	sac
	dc.b	$32,{1}
	ENDM

;dtv SIR #<imm>
	MAC	sir
	dc.b	$42,{1}
	ENDM

;dtv BRA <rel>
	MAC	bra
_TMPBRA	set	{1}-2-.
	if	_TMPBRA < -128 || _TMPBRA > 127
	ERROR 	"Branch to long!"
	endif
	dc.b	$12,_TMPBRA
	ENDM

ADDR_ONLY	set	1
	include	"sys.asm"

tmp_zp	equ	$fe	
	
	seg	code
	org	$0880
;**************************************************************************
;*
;* SysAddress... When run we will enter here!
;*
;******
SysAddress:

; install the server
	sei

; restore sysline (if we were newed)
	lda	#<EndLine
	sta	$0801
	lda	#>EndLine
	sta	$0802
; modify initial jump to jump to the trampoline
	lda	#<trampoline
	sta	sys_addr+1
	lda	#>trampoline
	sta	sys_addr+2

	sir	$e9
; map the selected target (default=$018000-$01c000) at $8000-$c000
	ldy	cfg_dtvtrans_bank
	sty	trmp_sm1+1
	sty	trmp2_sm1+1
; skip + burst
	ldx	#%00000011
	sir	$12
	
	lda	#1
	sta	$d03f
	lda	#%00100000
	sta	$d03c

	ldy	#>[code_end-code_start+$ff]
	ldx	#0
sa_lp1:
sa_sm1:
	lda	code_start,x
sa_sm2:
	sta	$8000,x
	inx
	bne	sa_lp1
	inc	sa_sm1+2
	inc	sa_sm2+2
	dey
	bne	sa_lp1

	ldx	#end_conf-start_conf-1
sa_lp2:
	lda	start_conf,x
	sta	start_conf_mon,x
	dex
	bpl	sa_lp2

	lda	cfg_dtvtrans_bank
	cmp	#$06		; default mapping?
	beq	sa_skp1		; yes, skip $018000 trampoline

	sir	$e9
; map $018000 at $8000-$c000
	ldy	#$06
	sir	$12
; install trampoline at $018000
	ldx	#trampoline2_end-trampoline2-1
sa_lp3:
	lda	trampoline2_store,x
	sta	trampoline2,x
	dex
	bpl	sa_lp3

sa_skp1:
	lda	#%00000000
	sta	$d03c
	sta	$d03f
	sir	$e9
; map $008000 at $8000-$c000
	ldy	#$02
; no skip or burst
	tax
	sir	$12

; update the address in the startup text
	lda	#0
	sta	tmp_zp
	lda	cfg_dtvtrans_bank
	ldy	#<txt_bank1
	jsr	do_hex
	ldy	#<txt_bank2
	jsr	do_hex
	dec	dh_sm1+2
	lsr
	ror	tmp_zp
	lsr
	ror	tmp_zp
	tax
	ldy	#txt_start
	jsr	do_hex
	lda	tmp_zp
	jsr	do_hex
	txa
	ldy	#txt_end
	jsr	do_hex
	lda	tmp_zp
	clc
	adc	#TOTAL_SIZE>>8
	jsr	do_hex
	lda	#TOTAL_SIZE&$ff
	jsr	do_hex
	
; install a couple of trampolines.
	ldy	#trampoline_end-trampoline
sa_lp4:
	lda	trampoline-1,y
	sta	$cf08-1,y	; 53000
	sta	$2bc-1,y	; 700
	dey
	bne	sa_lp4
	cli
; print message Y=0
prt_lp1:
prt_sm1:
	lda	start_msg,y
	beq	prt_ex1
	jsr	$ffd2
	iny
	bne	prt_lp1
	inc	prt_sm1+2
	bra	prt_lp1
prt_ex1:
	lda	cfg_autostart
	beq	sa_exit
	jmp	trampoline
sa_exit:
	jmp	$a474		; return to basic

; update start_msg with hex byte
; Acc=byte, Y=offset
do_hex:
	pha
	lsr
	lsr
	lsr
	lsr
	jsr	dohnib
	pla
dohnib:
	pha
	and	#$0f
	clc
	adc	#"0"
	cmp	#"9"+1
	bcc	dh_skp1
	adc	#"A"-("9"+1)-1
dh_skp1:
dh_sm1:
	sta	start_msg+$0100,y
	iny
	pla
	rts

start_msg:
	dc.b	147,142		; Cls, uppercase
txt_start	equ	.-start_msg+$3b
txt_end		equ	.-start_msg+$42
txt_bank1	equ	.-start_msg+$115
txt_bank2	equ	.-start_msg+$121
	incbin	"strippedtext.bin"
;	dc.b	0

;***
; "easy start" trampoline
trampoline:
	sei
	sac	$dd
trmp_sm1:
	lda	#$06
	jmp	($4002)
trampoline_end:

;***
; trampoline used when not installed at $018000
trampoline2_store:
	rorg	$8000
trampoline2:
	dc.w	cold_start
	dc.w	0
	dc.b	"D"|$80,"T"|$80,"V"|$80,"8","0"
cold_start:
	sei
	cld
	ldx	#TRMP2_LEN
cs_lp1:
	lda	trmp2_code-1,x
	sta	$0108-1,x
	dex
	bne	cs_lp1
	jmp	$0108
trmp2_code:
	sac	$ee
trmp2_sm1	equ	trampoline2_store+[.-trampoline2]
	lda	#$06
	sac	$00
	jmp	($8000)
TRMP2_LEN	equ	.-trmp2_code
trampoline2_end:
	rend

; "payload"
code_start:
	incbin	"server.bin"
code_end:

; eof
